#include <cyg/kernel/kapi.h>
#include <pkgconf/uitron.h>
#include <cyg/compat/uitron/uit_func.h>
#include <cyg/io/io.h>
#include <cyg/io/serialio.h>

int init_sched(void);
void app_main(void);

externC void cyg_package_start(void)
{
	cyg_uitron_start(); 
}


void cyg_user_start(void)
{

}

void start_task2(void)
{
  sta_tsk(2,0x0);
}

void start_task3(void)
{
  sta_tsk(3, 0x0);
}

void start_task4(int schan)
{
  sta_tsk(4, schan);
}

void start_task5(void)
{
  sta_tsk(5, 0x0);
}

void dtask1(unsigned int dummy)
{
  init_sched();
  app_main();
}	

void dtask2(unsigned int dummy)
{
  while(1)
    {
    }
}

void dtask3(unsigned int dummy)
{
  while(1)
    {
    }
}

void dtask4(unsigned int dummy)
{
  while(1)
    {
    }
}

void dtask5(unsigned int dummy)
{
  while(1)
    {
    }
  
}


void my_scheduler(void)
{
  rot_rdq(0);
  ret_tmr();
}


int init_sched(void)
{
  ER ercd;
  T_DCYC dcyc;

 
  dcyc.exinf = (VP)0;
  dcyc.cycatr = TA_HLNG;
  dcyc.cychdr = (FP)&my_scheduler;
  dcyc.cycact = TCY_ON;
  dcyc.cyctim = 100;  /* 100 interrupts per seconds, => 100 * 1/100 = 1 */
  
  ercd = def_cyc(1,&dcyc);
  
  if(ercd != E_OK)
    {
      //      printf("Error, def_cyc returned : %x\n",(-ercd));
      return -1;    
    }
  return 0;
}



void app_main(void)
{
  start_task2();
  start_task3();
  start_task4(5);

  start_task5();

  while(1)
    {
    }
}
